import {
  GraphQLSchema,
  GraphQLObjectType,
  GraphQLString,
  GraphQLInt,
  GraphQLFloat,
  GraphQLList
} from 'graphql';


const IngredientType = new GraphQLObjectType({
  name: 'Ingredient',
  fields: {
    name: {
      type: GraphQLString
    },
    amount: {
      type: GraphQLFloat
    },
    measurement: {
      type: GraphQLString
    }
  }
});

const RecipeType = new GraphQLObjectType({
  name: 'Recipe',
  fields: {
    id: {
      type: GraphQLInt
    },
    name: {
      type: GraphQLString
    },
    ingredients: {
      type: new GraphQLList(IngredientType)
    },
    steps: {
      type: new GraphQLList(GraphQLString)
    },
    rating: {
      type: GraphQLInt
    }
  }
});

const QueryType = new GraphQLObjectType({
  name: 'Query',
  fields: {
    recipes: {
      type: new GraphQLList(RecipeType),
      resolve: (arg1, arg2, {recipes}) => {
        let res = [];
        recipes.find((err, results) => {
          res = [...results];
        });
        return res;
      }
    }
  }
});

export const schema = new GraphQLSchema({
  query: QueryType
});
