import express from 'express';
import logger from 'morgan';
import Bourne from 'bourne';
import graphqlHTTP from 'express-graphql';
import {schema} from '../schema/main';

const app = express();
const recipes = new Bourne('db/recipes.json');

app.use(logger('dev'));
app.use(express.static('public'));
app.use('/graphql', graphqlHTTP({
  schema,
  context: {recipes},
  graphql: true
}));

app.listen(3000, () => console.log(`Application running at 'http://localhost:3000'`));
