import React, {Component} from 'react';

class IngredientForm extends Component {
  static defaultProps = {
    onNewIngredient(ingredient) {},
    onClear() {}
  }

  constructor() {
    super();
    this.add = this.add.bind(this);
    this.clear = this.clear.bind(this);
  }

  add(event) {
    event.preventDefault();
    const {_ingredientName, _amount, _measurement} = this.refs;
    const {onNewIngredient} = this.props;
    onNewIngredient({
      name: _ingredientName.value,
      amount: _amount.value,
      measurement: _measurement.value
    });
    this.clearInputs();
  }

  clear(event) {
    event.preventDefault();
    const {onClear} = this.props;
    onClear();
    this.clearInputs();
  }

  clearInputs() {
    const {_ingredientName, _amount, _measurement} = this.refs;
    _ingredientName.value = '';
    _amount.value = '';
    _measurement.value = '';
    _amount.focus();
  }

  render() {
    return (
      <div className="ingredient-form">
        <input className="form-control" ref="_amount" type="text" placeholder="Amount"/>
        <input className="form-control" ref="_measurement" type="text" placeholder="Measurement"/>
        <input className="form-control" ref="_ingredientName" type="text" placeholder="Ingredient name"/>
        <div className="mt-2">
          <button className="btn btn-secondary mr-2" onClick={this.add}>Add Ingredient</button>
          <button className="btn btn-secondary mr-2" onClick={this.clear}>Clear Ingredient List</button>
        </div>
      </div>
    );
  }
}

export default IngredientForm;
